"use strict";

const fs = require("fs");
const stream = require("stream");
const { validateValue } = require("@validatem/core");
const isNodeStream = require("./");

let readable = fs.createReadStream("/dev/zero");
let writable = fs.createWriteStream("/dev/null");
let transform = new stream.Transform({ transform: (chunk, encoding, callback) => callback(chunk) });

console.log(validateValue(readable, [ isNodeStream.readable ])); // ReadStream { ... }

console.log(validateValue(writable, [ isNodeStream.writable ])); // WriteStream { ... }

console.log(validateValue(transform, [ isNodeStream.transform ])); // Transform { ... }

console.log(validateValue(transform, [ isNodeStream.anyReadable ])); // Transform { ... }

console.log(validateValue(transform, [ isNodeStream.readable ])); /*
	AggregrateValidationError: One or more validation errors occurred at 'Object.<anonymous>' in is-node-stream/example.js, at line 20 (<path>):
	 - Must be a Node.js Readable stream
*/
